diff -urN qmail-1.03-vanilla/md5.c qmail-1.03-md24/md5.c
--- qmail-1.03-vanilla/md5.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/md5.c	2006-09-12 19:51:33.000000000 +0200
@@ -0,0 +1,259 @@
+
+/**
+ * Copyright (C) 2005-2006 Tino Reichardt
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License Version 2, as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ * Written by Solar Designer in 2001 and placed in the public domain.
+ * There's absolutely no warranty.
+ */
+
+#include "md5.h"
+
+/**
+ * MD5 Message-Digest Algorithm - rfc 1321
+ */
+
+#define F(x, y, z)	((z) ^ ((x) & ((y) ^ (z))))
+#define G(x, y, z)	((y) ^ ((z) & ((x) ^ (y))))
+#define H(x, y, z)	((x) ^ (y) ^ (z))
+#define I(x, y, z)	((y) ^ ((x) | ~(z)))
+#define STEP(f, a, b, c, d, x, t, s) \
+	(a) += f((b), (c), (d)) + (x) + (t); \
+	(a) = (((a) << (s)) | (((a) & 0xffffffff) >> (32 - (s)))); \
+	(a) += (b);
+
+/*
+ * SET reads 4 input bytes in little-endian byte order and stores them
+ * in a properly aligned word in host byte order.
+ *
+ * The check for little-endian architectures which tolerate unaligned
+ * memory accesses is just an optimization.  Nothing will break if it
+ * doesn't work.
+ */
+#if defined(__i386__) || defined(__vax__)
+#define SET(n) (*(u32 *)&ptr[(n) * 4])
+#define GET(n) SET(n)
+#else
+#define SET(n) \
+	(ctx->block[(n)] = \
+	(u32)ptr[(n) * 4] | \
+	((u32)ptr[(n) * 4 + 1] << 8) | \
+	((u32)ptr[(n) * 4 + 2] << 16) | \
+	((u32)ptr[(n) * 4 + 3] << 24))
+#define GET(n) (ctx->block[(n)])
+#endif
+
+/*
+ * This processes one or more 64-byte data blocks, but does NOT update
+ * the bit counters.  There're no alignment requirements.
+ */
+static void *body(MD5_CTX *ctx, void *data, u32 size)
+{
+	u8 *ptr=data;
+	u32 a,b,c,d;
+	u32 saved_a, saved_b, saved_c, saved_d;
+
+	ptr = data;
+
+	a = ctx->a;
+	b = ctx->b;
+	c = ctx->c;
+	d = ctx->d;
+
+	do {
+		saved_a = a;
+		saved_b = b;
+		saved_c = c;
+		saved_d = d;
+/* Round 1 */
+		STEP(F, a, b, c, d, SET(0),  0xd76aa478, 7)
+		STEP(F, d, a, b, c, SET(1),  0xe8c7b756, 12)
+		STEP(F, c, d, a, b, SET(2),  0x242070db, 17)
+		STEP(F, b, c, d, a, SET(3),  0xc1bdceee, 22)
+		STEP(F, a, b, c, d, SET(4),  0xf57c0faf, 7)
+		STEP(F, d, a, b, c, SET(5),  0x4787c62a, 12)
+		STEP(F, c, d, a, b, SET(6),  0xa8304613, 17)
+		STEP(F, b, c, d, a, SET(7),  0xfd469501, 22)
+		STEP(F, a, b, c, d, SET(8),  0x698098d8, 7)
+		STEP(F, d, a, b, c, SET(9),  0x8b44f7af, 12)
+		STEP(F, c, d, a, b, SET(10), 0xffff5bb1, 17)
+		STEP(F, b, c, d, a, SET(11), 0x895cd7be, 22)
+		STEP(F, a, b, c, d, SET(12), 0x6b901122, 7)
+		STEP(F, d, a, b, c, SET(13), 0xfd987193, 12)
+		STEP(F, c, d, a, b, SET(14), 0xa679438e, 17)
+		STEP(F, b, c, d, a, SET(15), 0x49b40821, 22)
+/* Round 2 */
+		STEP(G, a, b, c, d, GET(1),  0xf61e2562, 5)
+		STEP(G, d, a, b, c, GET(6),  0xc040b340, 9)
+		STEP(G, c, d, a, b, GET(11), 0x265e5a51, 14)
+		STEP(G, b, c, d, a, GET(0),  0xe9b6c7aa, 20)
+		STEP(G, a, b, c, d, GET(5),  0xd62f105d, 5)
+		STEP(G, d, a, b, c, GET(10), 0x02441453, 9)
+		STEP(G, c, d, a, b, GET(15), 0xd8a1e681, 14)
+		STEP(G, b, c, d, a, GET(4),  0xe7d3fbc8, 20)
+		STEP(G, a, b, c, d, GET(9),  0x21e1cde6, 5)
+		STEP(G, d, a, b, c, GET(14), 0xc33707d6, 9)
+		STEP(G, c, d, a, b, GET(3),  0xf4d50d87, 14)
+		STEP(G, b, c, d, a, GET(8),  0x455a14ed, 20)
+		STEP(G, a, b, c, d, GET(13), 0xa9e3e905, 5)
+		STEP(G, d, a, b, c, GET(2),  0xfcefa3f8, 9)
+		STEP(G, c, d, a, b, GET(7),  0x676f02d9, 14)
+		STEP(G, b, c, d, a, GET(12), 0x8d2a4c8a, 20)
+/* Round 3 */
+		STEP(H, a, b, c, d, GET(5),  0xfffa3942, 4)
+		STEP(H, d, a, b, c, GET(8),  0x8771f681, 11)
+		STEP(H, c, d, a, b, GET(11), 0x6d9d6122, 16)
+		STEP(H, b, c, d, a, GET(14), 0xfde5380c, 23)
+		STEP(H, a, b, c, d, GET(1),  0xa4beea44, 4)
+		STEP(H, d, a, b, c, GET(4),  0x4bdecfa9, 11)
+		STEP(H, c, d, a, b, GET(7),  0xf6bb4b60, 16)
+		STEP(H, b, c, d, a, GET(10), 0xbebfbc70, 23)
+		STEP(H, a, b, c, d, GET(13), 0x289b7ec6, 4)
+		STEP(H, d, a, b, c, GET(0),  0xeaa127fa, 11)
+		STEP(H, c, d, a, b, GET(3),  0xd4ef3085, 16)
+		STEP(H, b, c, d, a, GET(6),  0x04881d05, 23)
+		STEP(H, a, b, c, d, GET(9),  0xd9d4d039, 4)
+		STEP(H, d, a, b, c, GET(12), 0xe6db99e5, 11)
+		STEP(H, c, d, a, b, GET(15), 0x1fa27cf8, 16)
+		STEP(H, b, c, d, a, GET(2),  0xc4ac5665, 23)
+/* Round 4 */
+		STEP(I, a, b, c, d, GET(0),  0xf4292244, 6)
+		STEP(I, d, a, b, c, GET(7),  0x432aff97, 10)
+		STEP(I, c, d, a, b, GET(14), 0xab9423a7, 15)
+		STEP(I, b, c, d, a, GET(5),  0xfc93a039, 21)
+		STEP(I, a, b, c, d, GET(12), 0x655b59c3, 6)
+		STEP(I, d, a, b, c, GET(3),  0x8f0ccc92, 10)
+		STEP(I, c, d, a, b, GET(10), 0xffeff47d, 15)
+		STEP(I, b, c, d, a, GET(1),  0x85845dd1, 21)
+		STEP(I, a, b, c, d, GET(8),  0x6fa87e4f, 6)
+		STEP(I, d, a, b, c, GET(15), 0xfe2ce6e0, 10)
+		STEP(I, c, d, a, b, GET(6),  0xa3014314, 15)
+		STEP(I, b, c, d, a, GET(13), 0x4e0811a1, 21)
+		STEP(I, a, b, c, d, GET(4),  0xf7537e82, 6)
+		STEP(I, d, a, b, c, GET(11), 0xbd3af235, 10)
+		STEP(I, c, d, a, b, GET(2),  0x2ad7d2bb, 15)
+		STEP(I, b, c, d, a, GET(9),  0xeb86d391, 21)
+
+		a += saved_a;
+		b += saved_b;
+		c += saved_c;
+		d += saved_d;
+
+		ptr += 64;
+	} while (size -= 64);
+
+	ctx->a = a; ctx->b = b; ctx->c = c; ctx->d = d;
+
+	return ptr;
+}
+
+void MD5_Init(MD5_CTX *ctx)
+{
+	ctx->a = 0x67452301;
+	ctx->b = 0xefcdab89;
+	ctx->c = 0x98badcfe;
+	ctx->d = 0x10325476;
+
+	ctx->lo = 0; ctx->hi = 0;
+}
+
+void MD5_Update(MD5_CTX *ctx, void *data, u32 size)
+{
+	u32 saved_lo, used, free;
+
+	saved_lo = ctx->lo;
+	if ((ctx->lo = (saved_lo + size) & 0x1fffffff) < saved_lo)
+		ctx->hi++;
+	ctx->hi += size >> 29;
+
+	used = saved_lo & 0x3f;
+
+	if (used) {
+		free = 64 - used;
+
+		if (size < free) {
+			memcpy(&ctx->buffer[used], data, size);
+			return;
+		}
+
+		memcpy(&ctx->buffer[used], data, free);
+		data = (u8 *)data + free;
+		size -= free;
+		body(ctx, ctx->buffer, 64);
+	}
+
+	if (size >= 64) {
+		data = body(ctx, data, size & ~(u32)0x3f);
+		size &= 0x3f;
+	}
+
+	memcpy(ctx->buffer, data, size);
+}
+
+void MD5_Final(u8 *result, MD5_CTX *ctx)
+{
+	u32 used, free;
+
+	used = ctx->lo & 0x3f;
+	ctx->buffer[used++] = 0x80;
+	free = 64 - used;
+
+	if (free < 8) {
+		memset(&ctx->buffer[used], 0, free);
+		body(ctx, ctx->buffer, 64);
+		used = 0;
+		free = 64;
+	}
+
+	memset(&ctx->buffer[used], 0, free - 8);
+
+	ctx->lo <<= 3;
+	ctx->buffer[56] = ctx->lo;
+	ctx->buffer[57] = ctx->lo >> 8;
+	ctx->buffer[58] = ctx->lo >> 16;
+	ctx->buffer[59] = ctx->lo >> 24;
+	ctx->buffer[60] = ctx->hi;
+	ctx->buffer[61] = ctx->hi >> 8;
+	ctx->buffer[62] = ctx->hi >> 16;
+	ctx->buffer[63] = ctx->hi >> 24;
+
+	body(ctx, ctx->buffer, 64);
+
+	result[0]  = ctx->a;
+	result[1]  = ctx->a >> 8;
+	result[2]  = ctx->a >> 16;
+	result[3]  = ctx->a >> 24;
+	result[4]  = ctx->b;
+	result[5]  = ctx->b >> 8;
+	result[6]  = ctx->b >> 16;
+	result[7]  = ctx->b >> 24;
+	result[8]  = ctx->c;
+	result[9]  = ctx->c >> 8;
+	result[10] = ctx->c >> 16;
+	result[11] = ctx->c >> 24;
+	result[12] = ctx->d;
+	result[13] = ctx->d >> 8;
+	result[14] = ctx->d >> 16;
+	result[15] = ctx->d >> 24;
+
+	memset(ctx, 0, sizeof(ctx));
+}
+#undef F
+#undef G
+#undef H
+#undef I
+#undef SET
+#undef GET
+#undef STEP
diff -urN qmail-1.03-vanilla/md5.h qmail-1.03-md24/md5.h
--- qmail-1.03-vanilla/md5.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/md5.h	2007-07-19 22:06:45.000000000 +0200
@@ -0,0 +1,38 @@
+#ifndef SW_MD5_H
+#define SW_MD5_H
+
+/**
+ * Copyright (C) 2005-2006 Tino Reichardt
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License Version 2, as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ * Written by Solar Designer in 2001 and placed in the public domain.
+ * There's absolutely no warranty.
+ */
+
+#include "typesx.h"
+#include <string.h>
+
+typedef struct {
+	u32 lo, hi;
+	u32 a,b,c,d;
+	u32 block[16];
+	u8 buffer[64];
+} MD5_CTX;
+
+extern void MD5_Init(MD5_CTX *ctx);
+extern void MD5_Update(MD5_CTX *ctx, void *data, u32 size);
+extern void MD5_Final(u8 *result, MD5_CTX *ctx);
+
+#endif
diff -urN qmail-1.03-vanilla/newfield.c qmail-1.03-md24/newfield.c
--- qmail-1.03-vanilla/newfield.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/newfield.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "fmt.h"
 #include "datetime.h"
 #include "stralloc.h"
diff -urN qmail-1.03-vanilla/out_log.c qmail-1.03-md24/out_log.c
--- qmail-1.03-vanilla/out_log.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/out_log.c	2007-07-19 20:56:22.000000000 +0200
@@ -0,0 +1,72 @@
+#include <sys/types.h>
+#include <unistd.h>
+
+#include "substdio.h"
+#include "now.h"
+#include "fmt.h"
+#include "out_log.h"
+
+void Out(char *s)
+{ substdio_puts(&ssout,s); return;}
+
+void Outn(char *s, int len)
+{ substdio_put(&ssout,s,len); return; }
+
+void Log(char *s)
+{ if (ctl_log_out > 0) if (sserr.fd>0) substdio_puts(&sserr,s); return; }
+
+void Logn(char *s, int len)
+{ if (ctl_log_out > 0) if (sserr.fd>0) substdio_put(&sserr,s,len); return; }
+
+void out(char *s) { Out(s); Log(s); return; }
+void outn(char *s, int len) { Outn(s,len); Logn(s,len); return; }
+
+int flush(void)
+{
+  int r1,r2;
+  r1=substdio_flush(&ssout);
+  r2=substdio_flush(&sserr);
+  if (r1 == -1 || r2 == -1) return -1;
+  return 0;
+}
+
+void doname(void)
+{
+  static int pid=0;
+  char pidstr[FMT_ULONG];
+
+  if (!pid) { pid=getpid(); }
+  pidstr[fmt_ulong(pidstr,pid)] = 0;
+  Log(name);Log(": pid ");Log(pidstr);Log(" ");
+  return;
+}
+
+void doserv(void)
+{
+  doname(); Log("S: ");
+  return;
+}
+
+void doeol(void)
+{
+  Out("\r"); out("\n");
+  return;
+}
+
+void out_err(char *s)
+{
+  doserv(); out(s); doeol(); flush();
+  return;
+}
+
+void dounique(void)
+{
+  char *s=unique;
+
+  s += fmt_uint(s,getpid());
+  s += fmt_str(s,".");
+  s += fmt_ulong(s,(unsigned long) now());
+  s += fmt_str(s,"@");
+  s = 0;
+  return;
+}
diff -urN qmail-1.03-vanilla/out_log.h qmail-1.03-md24/out_log.h
--- qmail-1.03-vanilla/out_log.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/out_log.h	2007-07-28 15:54:54.000000000 +0200
@@ -0,0 +1,37 @@
+#include "substdio.h"
+#include "fmt.h"
+
+#define VERSION "md24"
+
+/* have to be provided by qmail-smtpd, qmail-popup and qmail-remote */
+extern char *name;
+extern char unique[];
+extern char ssinbuf[];
+extern char ssoutbuf[];
+extern char sserrbuf[];
+
+extern int ctl_log_out;
+
+extern substdio ssin;
+extern substdio ssout;
+extern substdio sserr;
+
+/* overview:
+ * Log()   = append to logfile
+ * Out()   = append to server output
+ * out()   = append to logfile+server output
+ * flush() = flush logfile+server buffers
+ */
+extern void Log(char *s);
+extern void Out(char *s);
+extern void out(char *s);
+extern void Logn(char *s, int len);
+extern void Outn(char *s, int len);
+extern void outn(char *s, int len);
+
+extern int  flush(void);
+extern void doname(void);     /* logs 'name of prog' */
+extern void doserv(void);     /* logs 'name: S: ' */
+extern void doeol(void);      /* logs a <NL>, but write <CRNL> to stdout */
+extern void dounique(void);   /* fill unique */
+extern void out_err(char *s); /* name: S: *s EOL + flush() */
diff -urN qmail-1.03-vanilla/predate.c qmail-1.03-md24/predate.c
--- qmail-1.03-vanilla/predate.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/predate.c	2007-07-19 20:56:22.000000000 +0200
@@ -10,6 +10,7 @@
 #include "subfd.h"
 #include "readwrite.h"
 #include "exit.h"
+#include "sig.h"
 
 #define FATAL "predate: fatal: "
 
@@ -20,7 +21,7 @@
 char num[FMT_ULONG];
 char outbuf[1024];
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
diff -urN qmail-1.03-vanilla/preline.c qmail-1.03-md24/preline.c
--- qmail-1.03-vanilla/preline.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/preline.c	2007-07-19 20:56:22.000000000 +0200
@@ -20,13 +20,14 @@
 int flagufline = 1; char *ufline;
 int flagrpline = 1; char *rpline;
 int flagdtline = 1; char *dtline;
+int flagpipe = 0;
 
 char outbuf[SUBSTDIO_OUTSIZE];
 char inbuf[SUBSTDIO_INSIZE];
 substdio ssout = SUBSTDIO_FDBUF(write,1,outbuf,sizeof outbuf);
 substdio ssin = SUBSTDIO_FDBUF(read,0,inbuf,sizeof inbuf);
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -41,7 +42,7 @@
   if (!(rpline = env_get("RPLINE"))) die_usage();
   if (!(dtline = env_get("DTLINE"))) die_usage();
  
-  while ((opt = getopt(argc,argv,"frdFRD")) != opteof)
+  while ((opt = getopt(argc,argv,"frdFRDp")) != opteof)
     switch(opt) {
       case 'f': flagufline = 0; break;
       case 'r': flagrpline = 0; break;
@@ -49,6 +50,7 @@
       case 'F': flagufline = 1; break;
       case 'R': flagrpline = 1; break;
       case 'D': flagdtline = 1; break;
+      case 'p': flagpipe = 1; break;
       default: die_usage();
     }
   argc -= optind;
@@ -77,8 +79,10 @@
   if (flagufline) substdio_bputs(&ssout,ufline);
   if (flagrpline) substdio_bputs(&ssout,rpline);
   if (flagdtline) substdio_bputs(&ssout,dtline);
-  if (substdio_copy(&ssout,&ssin) != 0)
-    strerr_die2sys(111,FATAL,"unable to copy input: ");
+  if (substdio_copy(&ssout,&ssin) != 0) {
+    if (errno!=error_pipe || !flagpipe)
+      strerr_die2sys(111,FATAL,"unable to copy input: ");
+  }
   substdio_flush(&ssout);
   close(1);
  
diff -urN qmail-1.03-vanilla/prot.c qmail-1.03-md24/prot.c
--- qmail-1.03-vanilla/prot.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/prot.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,16 +1,20 @@
+#include <sys/types.h>
+#include <unistd.h>
+#include <grp.h>
 #include "hasshsgr.h"
 #include "prot.h"
 
 /* XXX: there are more portability problems here waiting to leap out at me */
 
-int prot_gid(gid) int gid;
+int prot_gid(int gid)
 {
 #ifdef HASSHORTSETGROUPS
   short x[2];
   x[0] = gid; x[1] = 73; /* catch errors */
   if (setgroups(1,x) == -1) return -1;
 #else
-  if (setgroups(1,&gid) == -1) return -1;
+  const gid_t G=gid; /* fix warning of gcc */
+  if (setgroups(1,&G) == -1) return -1;
 #endif
   return setgid(gid); /* _should_ be redundant, but on some systems it isn't */
 }
diff -urN qmail-1.03-vanilla/qbiff.c qmail-1.03-md24/qbiff.c
--- qmail-1.03-vanilla/qbiff.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qbiff.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,5 +1,6 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
 #include <utmp.h>
 #ifndef UTMP_FILE
 #ifdef _PATH_UTMP
@@ -50,7 +51,7 @@
 }
 void finishheader() { ; }
 
-void main()
+int main()
 {
  char *user;
  char *sender;
diff -urN qmail-1.03-vanilla/qmail.c qmail-1.03-md24/qmail.c
--- qmail-1.03-vanilla/qmail.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "substdio.h"
 #include "readwrite.h"
 #include "wait.h"
@@ -6,8 +8,17 @@
 #include "fd.h"
 #include "qmail.h"
 #include "auto_qmail.h"
+#include "env.h"
 
-static char *binqqargs[2] = { "bin/qmail-queue", 0 } ;
+static char *binqqargs[2] = { 0, 0 } ;
+
+static void setup_qqargs()
+{
+  if(!binqqargs[0])
+    binqqargs[0] = env_get("QMAILQUEUE");
+  if(!binqqargs[0])
+    binqqargs[0] = "bin/qmail-queue";
+}
 
 int qmail_open(qq)
 struct qmail *qq;
@@ -15,6 +26,8 @@
   int pim[2];
   int pie[2];
 
+  setup_qqargs();
+
   if (pipe(pim) == -1) return -1;
   if (pipe(pie) == -1) { close(pim[0]); close(pim[1]); return -1; }
  
@@ -88,38 +101,38 @@
   close(qq->fde);
 
   if (wait_pid(&wstat,qq->pid) != qq->pid)
-    return "Zqq waitpid surprise (#4.3.0)";
+    return "Z4.3.0 qq waitpid surprise";
   if (wait_crashed(wstat))
-    return "Zqq crashed (#4.3.0)";
+    return "Z4.3.0 qq crashed";
   exitcode = wait_exitcode(wstat);
 
   switch(exitcode) {
     case 115: /* compatibility */
-    case 11: return "Denvelope address too long for qq (#5.1.3)";
-    case 31: return "Dmail server permanently rejected message (#5.3.0)";
-    case 51: return "Zqq out of memory (#4.3.0)";
-    case 52: return "Zqq timeout (#4.3.0)";
-    case 53: return "Zqq write error or disk full (#4.3.0)";
+    case 11: return "D5.1.3 envelope address too long for qq";
+    case 31: return "D5.3.0 mail server permanently rejected message";
+    case 51: return "Z4.3.0 qq out of memory";
+    case 52: return "Z4.3.0 qq timeout";
+    case 53: return "Z4.3.0 qq write error or disk full";
     case 0: if (!qq->flagerr) return ""; /* fall through */
-    case 54: return "Zqq read error (#4.3.0)";
-    case 55: return "Zqq unable to read configuration (#4.3.0)";
-    case 56: return "Zqq trouble making network connection (#4.3.0)";
-    case 61: return "Zqq trouble in home directory (#4.3.0)";
+    case 54: return "Z4.3.0 qq read error";
+    case 55: return "Z4.3.0 qq unable to read configuration";
+    case 56: return "Z4.3.0 qq trouble making network connection";
+    case 61: return "Z4.3.0 qq trouble in home directory";
     case 63:
     case 64:
     case 65:
     case 66:
-    case 62: return "Zqq trouble creating files in queue (#4.3.0)";
-    case 71: return "Zmail server temporarily rejected message (#4.3.0)";
-    case 72: return "Zconnection to mail server timed out (#4.4.1)";
-    case 73: return "Zconnection to mail server rejected (#4.4.1)";
-    case 74: return "Zcommunication with mail server failed (#4.4.2)";
+    case 62: return "Z4.3.0 qq trouble creating files in queue";
+    case 71: return "Z4.3.0 mail server temporarily rejected message";
+    case 72: return "Z4.4.1 connection to mail server timed out";
+    case 73: return "Z4.4.1 connection to mail server rejected";
+    case 74: return "Z4.4.2 communication with mail server failed";
     case 91: /* fall through */
-    case 81: return "Zqq internal bug (#4.3.0)";
-    case 120: return "Zunable to exec qq (#4.3.0)";
+    case 81: return "Z4.3.0 qq internal bug";
+    case 120:return "Z4.3.0 unable to exec qq";
     default:
       if ((exitcode >= 11) && (exitcode <= 40))
-	return "Dqq permanent problem (#5.3.0)";
-      return "Zqq temporary problem (#4.3.0)";
+        return "D5.3.0 qq permanent problem";
+      return "Z4.3.0 qq temporary problem";
   }
 }
diff -urN qmail-1.03-vanilla/qmail-clean.c qmail-1.03-md24/qmail-clean.c
--- qmail-1.03-vanilla/qmail-clean.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-clean.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,5 +1,6 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
 #include "readwrite.h"
 #include "sig.h"
 #include "now.h"
@@ -31,7 +32,7 @@
  time = now();
  dir = opendir("pid");
  if (!dir) return;
- while (d = readdir(dir))
+ while ((d = readdir(dir)))
   {
    if (str_equal(d->d_name,".")) continue;
    if (str_equal(d->d_name,"..")) continue;
@@ -49,7 +50,7 @@
 
 void respond(s) char *s; { if (substdio_putflush(subfdoutsmall,s,1) == -1) _exit(100); }
 
-void main()
+int main()
 {
  int i;
  int match;
@@ -73,22 +74,26 @@
    if (line.len < 7) { respond("x"); continue; }
    if (line.len > 100) { respond("x"); continue; }
    if (line.s[line.len - 1]) { respond("x"); continue; } /* impossible */
-   for (i = 5;i < line.len - 1;++i)
+   for (i = line.len - 2;i > 4;--i)
+    {
+     if (line.s[i] == '/') break;
      if ((unsigned char) (line.s[i] - '0') > 9)
       { respond("x"); continue; }
-   if (!scan_ulong(line.s + 5,&id)) { respond("x"); continue; }
+    }
+   if (line.s[i] == '/')
+     if (!scan_ulong(line.s + i + 1,&id)) { respond("x"); continue; }
    if (byte_equal(line.s,5,"foop/"))
     {
 #define U(prefix,flag) fmtqfn(fnbuf,prefix,id,flag); \
 if (unlink(fnbuf) == -1) if (errno != error_noent) { respond("!"); continue; }
-     U("intd/",0)
+     U("intd/",1)
      U("mess/",1)
      respond("+");
     }
    else if (byte_equal(line.s,4,"todo/"))
     {
-     U("intd/",0)
-     U("todo/",0)
+     U("intd/",1)
+     U("todo/",1)
      respond("+");
     }
    else
diff -urN qmail-1.03-vanilla/qmail-getpw.c qmail-1.03-md24/qmail-getpw.c
--- qmail-1.03-vanilla/qmail-getpw.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-getpw.c	2007-07-19 20:56:22.000000000 +0200
@@ -36,17 +36,19 @@
 	errno = 0;
 	pw = getpwnam(username);
 	if (errno == error_txtbsy) _exit(QLX_SYS);
-	if (pw)
-	  if (pw->pw_uid)
+	if (pw) {
+	  if (pw->pw_uid) {
 	    if (stat(pw->pw_dir,&st) == 0) {
 	      if (st.st_uid == pw->pw_uid) {
 		dash = "";
 		if (*extension) { ++extension; dash = "-"; }
 		return 1;
 	      }
-	    }
-	    else
+	    } else {
 	      if (error_temp(errno)) _exit(QLX_NFS);
+	    }
+	  }
+	}
       }
     if (extension == local) return 0;
     --extension;
@@ -55,7 +57,7 @@
 
 char num[FMT_ULONG];
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
diff -urN qmail-1.03-vanilla/qmail-inject.c qmail-1.03-md24/qmail-inject.c
--- qmail-1.03-vanilla/qmail-inject.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-inject.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "sig.h"
 #include "substdio.h"
 #include "stralloc.h"
@@ -55,7 +57,7 @@
 
 void put(s,len) char *s; int len;
 { if (flagqueue) qmail_put(&qqt,s,len); else substdio_put(subfdout,s,len); }
-void puts(s) char *s; { put(s,str_len(s)); }
+void out(s) char *s; { put(s,str_len(s)); }
 
 void perm() { _exit(100); }
 void temp() { _exit(111); }
@@ -94,8 +96,7 @@
 
  if (!flagqueue) substdio_flush(subfdout);
 
- if (flagqueue)
-  {
+ if (flagqueue) {
    int i;
 
    if (!stralloc_0(&sender)) die_nomem();
@@ -106,7 +107,7 @@
      if (!stralloc_0(&reciplist.sa[i])) die_nomem();
      qmail_to(&qqt,reciplist.sa[i].s);
     }
-   if (flagrh)
+   if (flagrh) {
      if (flagresent)
        for (i = 0;i < hrrlist.len;++i)
 	{
@@ -119,23 +120,24 @@
          if (!stralloc_0(&hrlist.sa[i])) die_nomem();
 	 qmail_to(&qqt,hrlist.sa[i].s);
 	}
+   }
 
    qqx = qmail_close(&qqt);
-   if (*qqx)
+   if (*qqx) {
      if (*qqx == 'D') {
        substdio_puts(subfderr,"qmail-inject: fatal: ");
        substdio_puts(subfderr,qqx + 1);
        substdio_puts(subfderr,"\n");
        substdio_flush(subfderr);
        perm();
-     }
-     else {
+     } else {
        substdio_puts(subfderr,"qmail-inject: fatal: ");
        substdio_puts(subfderr,qqx + 1);
        substdio_puts(subfderr,"\n");
        substdio_flush(subfderr);
        temp();
      }
+   }
   }
 
  _exit(0);
@@ -477,12 +479,11 @@
 void dodefaultreturnpath()
 {
  if (!stralloc_copys(&hackedruser,mailruser)) die_nomem();
- if (flaghackmess)
-  {
+ if (flaghackmess) {
    if (!stralloc_cats(&hackedruser,"-")) die_nomem();
-   if (!stralloc_catb(&hackedruser,strnum,fmt_ulong(strnum,(unsigned long) starttime))) die_nomem();
+   if (!stralloc_catb(&hackedruser,strnum,fmt_ulong(strnum,(unsigned long)starttime))) die_nomem();
    if (!stralloc_cats(&hackedruser,".")) die_nomem();
-   if (!stralloc_catb(&hackedruser,strnum,fmt_ulong(strnum,(unsigned long) getpid()))) die_nomem();
+   if (!stralloc_catb(&hackedruser,strnum,fmt_ulong(strnum,(unsigned long)getpid()))) die_nomem();
   }
  if (flaghackrecip)
    if (!stralloc_cats(&hackedruser,"-")) die_nomem();
@@ -549,16 +550,16 @@
 
   if (i == tocclist.len) return;
 
-  puts("Mail-Followup-To: ");
+  out("Mail-Followup-To: ");
   i = tocclist.len;
   while (i--) {
     if (!stralloc_copy(&sa,&tocclist.sa[i])) die_nomem();
     if (!stralloc_0(&sa)) die_nomem();
     if (!quote2(&sa2,sa.s)) die_nomem();
     put(sa2.s,sa2.len);
-    if (i) puts(",\n  ");
+    if (i) out(",\n  ");
   }
-  puts("\n");
+  out("\n");
 }
 
 void finishheader()
@@ -580,9 +581,9 @@
    if (!stralloc_0(&sa)) die_nomem();
    if (!quote2(&sa2,sa.s)) die_nomem();
 
-   puts("Return-Path: <");
+   out("Return-Path: <");
    put(sa2.s,sa2.len);
-   puts(">\n");
+   out(">\n");
   }
 
  /* could check at this point whether there are any recipients */
@@ -594,23 +595,23 @@
    if (!htypeseen[H_R_DATE])
     {
      if (!newfield_datemake(starttime)) die_nomem();
-     puts("Resent-");
+     out("Resent-");
      put(newfield_date.s,newfield_date.len);
     }
    if (!htypeseen[H_R_MESSAGEID])
     {
      if (!newfield_msgidmake(control_idhost.s,control_idhost.len,starttime)) die_nomem();
-     puts("Resent-");
+     out("Resent-");
      put(newfield_msgid.s,newfield_msgid.len);
     }
    if (!htypeseen[H_R_FROM])
     {
      defaultfrommake();
-     puts("Resent-");
+     out("Resent-");
      put(defaultfrom.s,defaultfrom.len);
     }
    if (!htypeseen[H_R_TO] && !htypeseen[H_R_CC])
-     puts("Resent-Cc: recipient list not shown: ;\n");
+     out("Resent-Cc: recipient list not shown: ;\n");
   }
  else
   {
@@ -630,7 +631,7 @@
      put(defaultfrom.s,defaultfrom.len);
     }
    if (!htypeseen[H_TO] && !htypeseen[H_CC])
-     puts("Cc: recipient list not shown: ;\n");
+     out("Cc: recipient list not shown: ;\n");
    finishmft();
   }
 
@@ -682,7 +683,7 @@
 #define RECIP_HEADER 3
 #define RECIP_AH 4
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -770,4 +771,5 @@
  if (headerbody(subfdin,doheaderfield,finishheader,dobody) == -1)
    die_read();
  exitnicely();
+ return 0; /* gcc happyness */
 }
